program pisquory;
uses crt,dos;  {dos kvuli GetDate)}
	       {crt kvuli clrscr, gotoXY, textcolor, atd..}

type  TObtiznost = (Normalni, Zacatecnik, Expert);
      Stavy = set of (prohral,vyhral,remizoval,nedohral);

const maxhrac=10 {50};
      jmenosouboru='H:\cejnaz1\pisqoury\hraci.ddt';  {ulozeno skore}
      VelikostPole=20;                     {maximalni delka nebo sirka pole}
      smerX : Array [1..4] of Integer = (1,0,1,-1);  {x smer. vekt.}
      smerY : Array [1..4] of Integer = (0,1,1,1);   {y smer. vekt.}
      Body : Array [TObtiznost,1..2,0..4] of Integer={[obtiznost,hrac,pocet kamenu v rade]}
       (((1,5,25,125,625),(1,4,16,64,256)),          {normalni obtiznost}
        ((1,1, 1,125,625),(1,4,16,64,256)),          {zacatecnik}
        ((1,5,25,125,625),(1,1, 1,64,256)));         {expert}

type TSymboly=(volno,krizek,kolecko,okoli); {ocenovaci fce}
     Tjmeno=string[10];  {lepsi omezit delku kvuli vypisu i prihlaseni}
     TInfo = RECORD symbol:Tsymboly;
             END;
     Tpole = array [-3..VelikostPole+4,-3..VelikostPole+4] of Tinfo;
             {zvetsene pole o okoli kvuli snadnejsimu ohodnocovani}

     dat =record d,m,r:integer{word}; end;
     hrac=record Jmeno:Tjmeno;
                 Datum:dat;
                 prohry,vyhry,remizy:integer;
                 uspesnost:integer;
          end; {udaje o hraci}
     lidi=array [1..maxhrac] of hrac;

var  Pole  : Tpole;
     Remiza:boolean;
     Tah:0..VelikostPole*VelikostPole; {pocita celkovy pocet tahu}
     x,y:Integer;                      {zadavane souradnice}
     m,n:Integer;                      {zadana velikost plochy}
     Obtiznost:TObtiznost;
     Zkratka,key,zacinat:char;         {pro volby}
     w:integer;                        {pro forcyklus uvodu}
     j:integer;
     jmeno,neutral:Tjmeno;
     konec:boolean;
     o,k,r:boolean;                    {kolecko,krizek,remiza-kdo vyhral..}
     stav : stavy;

     f:file of hrac;
     hraci:lidi;
     pocethracu:integer;
     p:integer;              {pocet hracu v listine kvuli cteni a zapisu}
     inlist:integer;         {kvuli zapisu do souboru-neuklada se maxhracu}


{-------------------------------Inicializace Hracu-------------------------}
procedure inithracu(var h:lidi);
var i,j:integer;
begin
 for i:=1 to maxhrac do
 begin
  with h[i] do
   begin
    jmeno:=neutral;
    datum.d:=0;
    datum.m:=0;
    datum.r:=0;
    prohry:=0;
    vyhry:=0;
    remizy:=0;
    uspesnost:=0;
   end;
 end;
end;  {proc inithraci}



{-------------------------------Vypis skore--------------------------------}
procedure vypis(var list:lidi);
var i,j,odsazeni:integer;
    usp:integer;
begin
  clrscr;
  textcolor(red); write('Seznam hracu podle uspesnosti':20);
  writeln;
  textcolor(yellow); writeln;
  writeln('Poradi':6,
          'Jmeno   ':14,
          'Posledni hra ':15,
          ' Prohry ':9,
          ' Vyhry  ':9,
          ' Remizy ':9,
          ' Uspesnost(%)':10);
  writeln;
  i:=1;
  textcolor(green);
  while (list[i].jmeno<>neutral) and (i<=maxhrac) do
   begin
    write(i:2);

    write(list[i].jmeno:18,
	  list[i].datum.d:6,'.',
          list[i].datum.m:2,'.',
          list[i].datum.r:4,
          list[i].prohry:8,
          list[i].vyhry:8,
          list[i].remizy:10,
          list[i].uspesnost:12);
    inc(i);
    writeln;
   end;
   gotoXY(34,24); textcolor(red+blink);write('Stiskni klavesu!!');
   readkey;
   normvideo;
end;

{----------------------------------Existuje--------------------------------}
function existuje(name:string):boolean;
var f:file of hrac;
begin
 {$I-}
 assign(f,name);
 reset(f);
 close(f);
 {$I+}
 existuje:=(IOResult = 0);
end;

{-------------------------------Zjistijmeno--------------------------------}
procedure zjistijmeno(var name:Tjmeno);
var delka,i:integer;
begin
clrscr;
gotoXY(30,9);
textcolor(lightgreen);
writeln('Vitam sveho soupere.');
gotoXY(30,11); textcolor(green);
write  ('Jak se jmenujes?  : ');
normvideo;
readln(name);
end; {konec zjistijmeno}


{--------------------------------JeVSeznamu--------------------------------}
function jevseznamu(name:Tjmeno; var h:lidi):boolean;
var i,j:integer;
    d1,d2:integer;
    je : boolean;
    pom1,pom2:Tjmeno;

begin
 pom1:=name;
 i:=0;
 je:=false;

 if h[1].jmeno<>neutral then  {jestli vubec nekdo v seznamu je}

 {velikost pisma neovlivni vysledek vyhledavani}
 d1:=length(pom1);
 for j:=1 to d1 do pom1[j]:=UpCase(pom1[j]); {prevedeno na velka pismena}

 repeat
  i:=i+1;
  pom2:=h[i].jmeno;
  d2:=length(h[i].jmeno);
  for j:=1 to d2 do pom2[j]:=UpCase(pom2[j]); {prevedeno na velka pismena}
  if pom1=pom2 then je:=true;
 until (h[i].jmeno=neutral) or (i=maxhrac) or je;

 jevseznamu:=je;
end;    {konec je v seznamu}


{-------------------------------Priprav pozici-----------------------------}
 procedure pripravpozici(poz:integer; var h:lidi);  {musi vynulovat hodnoty,
 protoze tam zustavaji od prednchoziho hrace}

 var j:integer;
 begin
  with h[poz] do     {init udaju}
    begin
     jmeno:=neutral;
     datum.d:=0;
     datum.m:=0;
     datum.r:=0;
     prohry:=0;
     vyhry:=0;
     remizy:=0;
     uspesnost:=0;
    end;
 end;  {procedure pripravpozici}


{---------------------------------Zrus hrace-------------------------------}
procedure zrus(name:Tjmeno;var h:lidi);
var i,pozice,kam:integer;
begin
 i:=1;
 while (name<>h[i].jmeno) and (i<=maxhrac) do inc(i);
 {na kterem miste je mazany hrac}
 pozice:=i;
 i:=1;
 while (h[i].jmeno<>neutral) and (i<maxhrac) do inc(i);
 {na kterem miste je prvni neobsazena pozice nebo posledni hrac}
 kam:=i;
 if pozice>maxhrac then begin clrscr;
                              writeln('hrac neni v seznamu!!');
                              textcolor(red+blink);
                              write('Stiskni klavesu!!');
                              readkey;
                        end
                   else begin
                         for i:=pozice to kam-1 do begin
                                                        pripravpozici(i,h);
                                                        h[i]:=h[i+1];
                                                       end;
                         with h[kam] do
                          begin
                           jmeno:=neutral;
                           datum.d:=0;
                           datum.m:=0;
                           datum.r:=0;
                           prohry:=0;
                           vyhry:=0;
                           remizy:=0;
                           uspesnost:=0;
                          end;
                        end;
end; {procedure zrus}

{--------------------------------Zapis stav--------------------------------}
procedure zapis(name:Tjmeno; state:stavy; var h:lidi);
var i,index,napoz:integer;
    Da,Mo,Y,DoW:word;
    pom:hrac;
    pom1,pom2:Tjmeno;
    d1,d2,j:integer;

begin
 i:=0;
 pom1:=name;
 d1:=length(pom1);
 for j:=1 to d1 do pom1[j]:=UpCase(pom1[j]); {prevedeno na velka pismena}

 repeat
  i:=i+1;
  pom2:=h[i].jmeno;
  d2:=length(h[i].jmeno);
  for j:=1 to d2 do pom2[j]:=UpCase(pom2[j]); {prevedeno na velka pismena}

 until pom1=pom2;
 index:=i;        {mam index hrace, kteremu pripisu udaje}
 if state=[vyhral] then h[index].vyhry:=h[index].vyhry+1
                else if state=[prohral] then h[index].prohry:=h[index].prohry+1
                else if state=[remizoval] then h[index].remizy:=h[index].remizy+1;
 GetDate(Y,Mo,Da,DoW);
 with h[index].datum do
 begin d:=Da;
       m:=Mo;
       r:=Y;
 end;

 if (h[index].prohry+h[index].vyhry)<>0 then
 h[index].uspesnost:=round((h[index].vyhry/
                     (h[index].prohry+h[index].vyhry)*100));

                     {konec zapisu hodnot-remiza se nezapocitava}
                     {zaradim podle uspesnosti}
  if (h[index].uspesnost>h[index-1].uspesnost) and ((index-1)>0) then
  begin
   i:=index-1;
   while h[i].uspesnost<h[index].uspesnost do dec(i);
   napoz:=i+1;
   pom:=h[index];
   for i:=index-1 downto napoz do h[i+1]:=h[i]; {sesype hrace nad nim}
   pripravpozici(napoz,h);
   h[napoz]:=pom;
  end else

 if (h[index].uspesnost<h[index+1].uspesnost) and ((index+1)<maxhrac) then
  begin
   i:=index+1;
   while h[i].uspesnost>h[index].uspesnost do inc(i);
   napoz:=i-1;
   pom:=h[index];
   for i:=index to napoz-1 do h[i]:=h[i+1]; {sesype hrace pod nim}
   pripravpozici(napoz,h);
   h[napoz]:=pom;
  end;


end;    {konec zapis}


{-------------------------------Novy Hrac----------------------------------}
procedure novy(name:Tjmeno; var h:lidi);   {noveho zaradim vzdy na zacatek}
var i,j,pozice,dni:integer;
    Da,Mo,Y,DoW:word;

begin
  i:=1;
  while (h[i].jmeno<>neutral) and (i<=maxhrac-1) do inc(i);
  {mam index prvni neobsazene pozice}
  {kdyz uz neni volna pozice -> posledni s nejmensi uspesnosti vypadne}
  pozice:=i;
  for i:=pozice downto 2 do begin pripravpozici(i,h);
                                  h[i]:=h[i-1]; {uvolneni prvniho mista}
                            end;
  pripravpozici(1,h);
  with h[1] do     {zadani udaju}
   begin
    jmeno:=name;
    GetDate(Y,Mo,Da,DoW);
    with h[1].datum do
    begin d:=Da;
          m:=Mo;
          r:=Y;
    end;

   end;
end;  {procedure novy}




{---------------------------------Navod------------------------------------}
procedure navod;
begin
clrscr;
writeln;
writeln;
textcolor(lightgreen);
writeln(' Ovladani je jednoduche. Zadate sve jmeno, kvuli poradi a pak si vyberete');
writeln('volbu z menu.  Hra zacina zvolenim obtiznosti.  Zadejte  n  jako normalni');
writeln('obtiznost nebo  z jako zacatecnik  nebo e jako expert.');
writeln(' Potom Vas pocitac vyzve ke zvoleni velikosti hraci plochy. Zadejte sirku');
writeln('v rozmezi od peti sloupcu  do dvaceti sloupcu a stisknete  enter. Zadejte');
writeln('vysku  v rozmezi  od peti radku  do dvaceti radku a stisknete enter. A na');
writeln('konec jeste volba,  zda chcete zacinat  a=ano,  n=ne.  Pote se Vam objevi');
writeln('hraci plocha a pod ni vyzva k zadani Vaseho tahu.');
textcolor(red);write('Pozor!!   ');textcolor(lightgreen);
writeln('Hraje se na krize, ne do ctverecku.');
writeln('Zadejte x-ovou souradnici (je to ta vodorovna, jak je zvykem) a stisknete');
writeln('enter. Pote y-ovou a stisknete enter.  Zadate-li souradnici spatne nic se');
writeln('nedeje.  Pocitac ji odmitne  a vyzve  Vas k novemu zadani.  Kdyz uz nekdo');
writeln('zvitezi, pocitac  ohlasi kdo a vrati se do menu.');
writeln;
writeln('  Preji prijemnou zabavu.');
writeln;
writeln(' P.S.: Kdyz uz  Vas to prestane bavit behem hry muzete ji ukoncit tak, ze');
writeln('       za x-ovou i y-ovou souradnici zadate nuly.');
gotoXY(31,24); textcolor(white+blink);write('Stiskni klavesu!!'); readkey;
normvideo;
end;


{-------------------------------KresliDesku--------------------------------}
procedure KresliDesku(s,v:integer); {s=sirka,v=vyska}
var zns,znr:integer;
    popisekY,popisekX:integer;
    i,j:integer;
begin  zns:=1;
       znr:=1;
       for popisekX:=1 to s do begin gotoXY (popisekX*3+2,1);
				     textcolor (green);
                                     write (zns);
                                     zns:=zns+1;
                                     end;
       for popisekY:=1 to v do begin gotoXY (1,popisekY+1);
                                     textcolor (lightred);
                                     write (znr);
                                     znr:=znr+1;
                                     end;
       textcolor(yellow);
       for i:=2 to s-1 do case Pole[i,1].symbol of
                               volno  : begin gotoXY ((((i+1)*3)-1),(2));
                                        write (chr(194));end;
			       kolecko: begin gotoXY ((((i+1)*3)-1),(2));
					      textcolor(green);
					      write ('O');
					      normvideo;
					      textcolor(yellow);end;
			       krizek : begin gotoXY ((((i+1)*3)-1),(2));
					      textcolor(red);
					      write ('X');
					      normvideo;
					      textcolor(yellow);end;
                          end;
       for i:=2 to s-1 do case Pole[i,v].symbol of
                               volno  : begin gotoXY ((((i+1)*3)-1),(v+1));
					write (chr(193));end;
                               kolecko: begin gotoXY ((((i+1)*3)-1),(v+1));
					      textcolor(green);
					      write ('O');
					      normvideo;
					      textcolor(yellow);end;
			       krizek : begin gotoXY ((((i+1)*3)-1),(v+1));
					      textcolor(red);
					      write ('X');
					      normvideo;
					      textcolor(yellow);end;
                          end;
       for j:=2 to v-1 do case Pole[1,j].symbol of
                               volno  : begin gotoXY (5,j+1);
                                        write (chr(195));end;
			       kolecko: begin gotoXY (5,j+1);
					      textcolor(green);
					      write ('O');
					      normvideo;
					      textcolor(yellow);end;
			       krizek : begin gotoXY (5,j+1);
					      textcolor(red);
					      write ('X');
					      normvideo;
					      textcolor(yellow);end;
			  end;
       for j:=2 to v-1 do case Pole[s,j].symbol of
			       volno  : begin gotoXY ((((s+1)*3-1)),j+1);
					write (chr(180)); end;
			       kolecko: begin gotoXY ((((s+1)*3-1)),j+1);
					      textcolor(green);
					      write ('O');
					      normvideo;
					      textcolor(yellow);end;
			       krizek : begin gotoXY ((((s+1)*3-1)),j+1);
					      textcolor(red);
					      write ('X');
					      normvideo;
					      textcolor(yellow);end;
			  end; {konec hrany}

       case Pole[1,1].symbol of
	    volno  : begin gotoXY(5,2); write (chr(218));end;
	    kolecko: begin gotoXY(5,2); textcolor(green);write ('O');normvideo;textcolor(yellow);end;
	    krizek : begin gotoXY(5,2); textcolor(red);write ('X');normvideo;textcolor(yellow);end;end;
       case Pole[1,v].symbol of
	    kolecko: begin gotoXY(5,v+1); textcolor(green);write ('O');normvideo;textcolor(yellow);end;
	    krizek : begin gotoXY(5,v+1); textcolor(red);write ('X');normvideo;textcolor(yellow);end;
	    volno  : begin gotoXY(5,v+1); write (chr(192));end;end;
       case Pole[s,1].symbol of
	    kolecko: begin gotoXY(s*3+2,2); textcolor(green);write ('O');normvideo;textcolor(yellow);end;
	    krizek : begin gotoXY(s*3+2,2); textcolor(red);write ('X');normvideo;textcolor(yellow);end;
	    volno  : begin gotoXY(s*3+2,2); write (chr(191));end;end;
       case Pole[s,v].symbol of
	    kolecko: begin gotoXY(s*3+2,v+1); textcolor(green);write ('O');normvideo;textcolor(yellow);end;
	    krizek : begin gotoXY(s*3+2,v+1); textcolor(red);write ('X');normvideo;textcolor(yellow);end;
	    volno  : begin gotoXY(s*3+2,v+1); write (chr(217));end;end;
       {konec rohy}

       for i:=2 to s-1 do
	   for j:=2 to v-1 do case Pole[i,j].symbol of
				   volno  : begin gotoXY((((i+1)*3-1)),j+1);
					    write (chr(197));end;
				   kolecko: begin gotoXY((((i+1)*3-1)),j+1);
						  textcolor(green);
						  write ('O');
						  normvideo;
						  textcolor(yellow);end;
				   krizek : begin gotoXY((((i+1)*3-1)),j+1);
						  textcolor(red);
						  write ('X');
						  normvideo;
						  textcolor(yellow);end;
			      end;  {konec vnitrni krize}
       for i:=1 to s-1 do
	   for j:=1 to v do begin gotoXY((((i+1)*3)),j+1);
				  write (chr(45));write(chr(45));
				  end;  {konec vnitrni hranky}
end;

{-------------------------------Inicializace-------------------------------}
procedure InitPole(s,v:integer);   {inicializuju volne a za okrajem}
var X, Y: Integer;
begin

  for X:=1-4 to s+4 do
    for Y:=1-4 to v+4 do
    if (X<1) or (Y<1) or (X>s) or (Y>v)
      then Pole[X,Y].symbol := Okoli
      else begin
             Pole[X,Y].symbol := Volno;
           end;
end;

{----------------------------UdlejTah-------------------------------------}
procedure NejlepsiPozice(Kamen: TSymboly; s,v:integer; var X, Y: Integer; obtiznost:TObtiznost);

  function Ocen(Kamen: TSymboly; s,v:integer; X, Y: Integer; obtiznost:TObtiznost): Integer;
   var Smer, Pozice, Cena, Kriz: Integer;
    Rada: Array [TSymboly] of Integer;           {kolik symbolu v peticic
                                                  stejneho druhu}
     begin
      Cena := 0;
       for Smer := 1 to 4 do                     {prochazi 4 smery}
	for Pozice := -4 to 0 do                 {v kazdem smeru 5 krizu}
         begin
          Rada[Volno]   := 0;
          Rada[Kolecko] := 0;
          Rada[Krizek]  := 0;
          Rada[Okoli]   := 0;

          for Kriz := 0 to 4 do {spocita kolik jakych symbolu je v petici}
           inc( Rada[ Pole[ X + smerX[Smer] * (Pozice+Kriz),
                            Y + smerY[Smer] * (Pozice+Kriz)].symbol ]);
          if (Rada[Okoli] = 0) and (Rada[Krizek]*Rada[Kolecko]=0) then
        {cena krize roste pokud je cela petice v poli a obsahuje}
        { jen jeden druh kamenu                                 }
          begin
            inc(Cena, Body[Obtiznost,2,Rada[Kolecko]]
                    + Body[Obtiznost,1,Rada[Krizek]]);  {cena roste o body}
          end;   {konec ceneni petice}
      end;       {konec ceneni ve vsech smerech}
  Ocen:=Cena;
end;     {Konec procedury Ocen}

 var Nejlepsi, NejX, NejY, Aktualni, AktX, AktY: Integer;
 begin
   Nejlepsi := -1;   {hodnota nejlepe ohodnocene pozice}
   for AktX := 1 to s do
     for AktY := 1 to v do     {aktualni pozice}
       if Pole[AktX,AktY].symbol = Volno
         then begin
               Aktualni := Ocen(Kamen, s,v, AktX,AktY,obtiznost);
               if (Aktualni > Nejlepsi) or ((Aktualni = Nejlepsi) and (Random(3) = 1))
               {Kdyz ma vic krizu stejnou cenu vybere se jeden z nich nahodne}
                 then begin
                        NejX := AktX;
                        NejY := AktY;
                        Nejlepsi := Aktualni;
                      end;
              end;
   X := NejX;
   Y := NejY;                   {nejdrazsi kriz na X,Y}
 end;   {konec udelejTah}



{----------------------------OverTah--------------------------------------}
function OverTah(X,Y:integer):boolean;
begin 
              if Pole[X,Y].symbol=volno then overtah:=true
                                        else overtah:=false;
end;

{------------------------------Vyhra--------------------------------------}
function Vyhra(Kamen: Tsymboly; X, Y: Integer): Boolean;
var Smer, Pozice, PocetVRade, Kriz: Integer;
begin
  Vyhra := False;
  for Smer := 1 to 4 do     {prochazi vertikalu, horizontalu a jejich osy}
    for Pozice := -4 to 0 do   {prochazi pozice v 1 ze 4 smeru = posune
                                moznou petici pres X,Y}
      begin
        PocetVRade := 0;
	for Kriz := 0 to 4 do           {spocita kolik kamenu je v petici}
          if  Pole[ X + smerX[Smer] * (Pozice+Kriz),
                    Y + smerY[Smer] * (Pozice+Kriz)].symbol = Kamen
                    {jestli je symbol na dalsim krizi v rade}
             then inc(PocetVRade);
        if PocetVRade = 5 then begin
                            Vyhra := True;
                          end;
      end;
end;

{---------------------------Famfary Vitez+Porazeny+Remiza----------------}

procedure vitez;
var i:integer;
begin
 sound(800); delay(300); nosound; delay(50);
 for i:=1 to 2 do begin sound(1000); delay(200); nosound; delay(50); end;
 sound(1200); delay(500); nosound; delay(50);
 sound(1000); delay(200); nosound; delay(50);
 sound(1200); delay(500); nosound;
end;

procedure porazeny;
var i:integer;
begin
 sound(1200); delay(50); nosound; delay(50);
 sound(900); delay(80); nosound; delay(50);
 sound(900); delay(80); nosound; delay(100);
 sound(400); delay(400); nosound;     {400 na 1500 a mas tadadady}
end;

procedure Plichta;
begin
 sound(1200); delay(500); nosound; delay(50);
 sound(800); delay(200); nosound; delay(50);
 sound(1200); delay(500); nosound;
end;

{---------------------------------Hlavni HRA------------------------------}
procedure hra(name:Tjmeno);
var konec:boolean;
begin
konec:=false;
repeat
      Remiza:=false;
      Tah:=1;
      m:=20;
      n:=20;
      clrscr;
      writeln;
      writeln('Zvol si obtiznost a stiskni enter.');
      write  ('N=normalni, Z=Zacatecnik, E=Expert');
      repeat
      zkratka:=readkey;
      until UpCase(Zkratka) in ['N','Z','E'];
      case UpCase(zkratka) of 'N':begin Obtiznost:=Normalni;
                                        writeln;
                                        textcolor(red);
                                        writeln('Hrajem normalne!');
					normvideo;
                                  end;
                              'Z':begin Obtiznost:=Zacatecnik;
                                        writeln;
                                        textcolor(red);
                                        writeln('Tak ZELENACI, mozna Te necham i vyhrat!');
                                        normvideo;
                                  end;
                              'E':begin Obtiznost:=Expert;
                                        writeln;
                                        textcolor(red);
                                        writeln('To si veris, EXPERTE. Jdeme na to!');
                                        normvideo;
                                  end;
                           end;   {konec volby obtiznosti}

      writeln;
      writeln('Na jak velkem poli chces hrat?');
      writeln('minimalne 5*5,maximalne 20*20)!!');
      write('Pocet sloupcu:');
      repeat read(m) until (m<=VelikostPole) and (m>=5);
      write('Pocet  radku :');
      repeat read(n) until (n<=VelikostPole) and (n>=5);
      InitPole(m,n);     {konec volny velikosti plochy}

      writeln;
      write('Chces zacinat hru? A=ano, N=ne');
      repeat zacinat:=readkey until Upcase(zacinat) in ['A','N'];
      case UpCase(zacinat) of 'A':Tah:=Tah;
                              'N':Tah:=Tah+1;
      end;  {konec volby prvniho tahu}

      repeat clrscr;
             Kreslidesku(m,n);
             textcolor(white);
             gotoXY(1,22);
             {v lichem tahu hraje vzdy hrac}
             if odd(Tah) then if name='comp1' then

                            begin writeln('hraje pocitac zacatecnik');
				  Repeat NejlepsiPozice(kolecko,m,n,x,y,zacatecnik);
                                  {udela krizek do pole m*n na souradnice x*y}
				  delay(200);
                                  until  overtah(x,y);

                            end else

                              if name='comp2' then

                            begin writeln('hraje pocitac normalne');
                                  Repeat NejlepsiPozice(kolecko,m,n,x,y,normalni);
                                  {udela krizek do pole m*n na souradnice x*y}
				  delay(200);
                                  until  overtah(x,y);

                            end else

                              if name='comp3' then

                            begin writeln('hraje pocitac expert');
				  Repeat NejlepsiPozice(kolecko,m,n,x,y,expert);
                                  {udela krizek do pole m*n na souradnice x*y}
				  delay(200);
                                  until  overtah(x,y);

                            end else

                            begin writeln(name,' hraje koleckem!');
                                  write ('zadej x:');
                                  repeat read (x);
                                  until (x<=m) and (x>=0);
                                  write ('zadej y:');
                                  repeat read (y);
                                  until (y<=n) and (y>=0);
                            end

                       else begin writeln('hraje pocitac');
                                  Repeat NejlepsiPozice(krizek,m,n,x,y,obtiznost);
                                  {udela krizek do pole m*n na souradnice x*y}
					 delay(200);
				  {zpozdeni, aby se to dalo sledovat}
                                  until  overtah(x,y);

                            end;

             if ((x=0) and (y=0)) then konec:=true;
             if overtah(x,y) then if odd(Tah)
             then begin Pole[x,y].symbol:=kolecko; Tah:=Tah+1; end
	     else begin Pole[x,y].symbol:=krizek; Tah:=Tah+1; end;
             {udaje zapsany do pole a zkontroluju remizu}

      if UpCase(zacinat)='A' then if Tah-1=m*n then Remiza:=true;
      if UpCase(zacinat)='N' then if Tah-2=m*n then Remiza:=true;

      o:=vyhra(kolecko,x,y);
      k:=vyhra(krizek,x,y);
      r:=Remiza;

      until  o or k or r or konec;
      konec:=true; {SKONCILO VYHROU, PROHROU NEBO REMIZOU}

      stav:=[nedohral];
      if o then stav:=[vyhral]
           else if k then stav:=[prohral]
                     else if r then stav:=[remizoval];

      zapis(jmeno,stav,hraci);
      {musel jsem zjistit stav, abych ho mohl zapsat}

      clrscr;
      KresliDesku(m,n);
      gotoXY(1,22);
      if vyhra(kolecko,x,y) then begin vitez;
                                       textcolor (red);
                                       writeln('vyhral ',name);
                                       normvideo;
                                 end;
      if vyhra(krizek,x,y) then begin porazeny;
                                      textcolor (blue);
                                      writeln('vyhral pocitac');
				      normvideo;
                                end;
      if Remiza then begin textcolor (cyan);
                            writeln('Remiza');
                            normvideo;
                            plichta;
                      end;
      writeln;
      textcolor(white+blink); gotoXY(31,24);
      Write('Stiskni klavesu!');readkey;
      normvideo;

until konec;

end;

{---------------------------------Menu-------------------------------------}
procedure menu(name:Tjmeno);
const  heslo:array [1..5] of char = ('a','h','o','j',#13);

var zn,ch:char;
    jm,meno:Tjmeno;
    i:integer;
    spravne:array [1..6] of boolean;
    gut:boolean;

begin
 repeat
 clrscr;
 GotoXY(30,1);textcolor(lightgreen); write('Hraje ');
 textcolor(red+blink); write(name);
 textcolor(lightgreen); write(' proti me malickosti.');
 GotoXY(5,5); textcolor(blue); write  ('ESC .....konec');
 GotoXY(5,7); textcolor(blue); write  ('N .......navod');
 GotoXY(5,9); textcolor(blue); write  ('Z .......zacit hru');
 GotoXY(5,11);textcolor(blue); write  ('S .......skore');
 GotoXY(5,13);textcolor(blue); write  ('V .......vymaz hrace (pokud znas heslo)');
 gotoXY(5,17); textcolor(red);write('Zadej volbu!!');
 normvideo;

 zn:=readkey;
  case zn of
       'N','n' : begin
                  navod;
                 end;
       'Z','z' : begin
                  hra(jmeno);
                 end;
       'S','s' : begin
                  vypis(hraci);
                 end;
       'V','v' : begin
                  clrscr;
                  for i:= 1 to 6 do spravne[i]:=false;
                  write('Zadej heslo : ');
                  i:=0;
                  repeat ch:=readkey;
                         i:=i+1;
                         if i<=5 then begin
                         spravne[6]:=true;
			 if ch=heslo[i] then spravne[i]:=true
                                        else spravne[i]:=false; end
                                 else spravne[6]:=false;
                  until ch=#13;
                  if (spravne[1]) and (spravne[2]) and (spravne[3]) and
                     (spravne[4]) and (spravne[5]) and (spravne[6])
                     then gut:=true
                     else gut:=false;

                  writeln;
                  writeln;
                  if   gut   then begin
                                   write('Koho chces smazat? : ');
                                   readln(meno);
                                   zrus(meno,hraci);
                                  end
                                   else begin writeln('Spatne heslo!!');
                                              textcolor(white+blink);
                                              gotoXY(31,24);
                                              write('Stiskni klavesu!');
					      readkey;
                                              normvideo;
                                        end;
                 end;

  end;
 until zn=chr(27);
 zapis(jmeno,[nedohral],hraci); {kdyz byl hrac novy, musel jsem ho zapsat,
                                 aby se spravne zaradil}
end;  {konec menu}

{---------------------------Hlavni program--------------------------------}

BEGIN
 clrscr;
 for w:=1 to 5 do writeln;
 writeln('         *************************************************************');
 for w:=1 to 5 do
 writeln('         *                                                           *');
 writeln('         *************************************************************');
 GotoXY(35,8); textcolor(white); write ('PISQUORY');
 GotoXY(35,9); textcolor(red); write ('ver. 2.c');
 GotoXY(31,10); textcolor(lightblue); write ('by Zdenek Cejnar');
 gotoXY(31,24); textcolor(white+blink);write('Stiskni klavesu!!'); readkey;
 normvideo;  {konec uvodni obrazovky}

 neutral:=chr(255); {tento string bude inicializacni jmeno}

 inithracu(hraci);

 {overeni existence souboru a jeho pripadne otevreni}
 if not existuje(jmenosouboru) then begin assign(f,jmenosouboru);
					  rewrite(f);
					  close(f);
				    end;

 assign(f,jmenosouboru);
 p:=0;
 reset(f);
 if not eof(f) then
 repeat
  p:=p+1;
  read(f,hraci[p]);
 until eof(f);  {konec nacteni hracu do vnitrni pameti}
 close(f);


 zjistijmeno(jmeno);

 if not (jevseznamu(jmeno,hraci)) then novy(jmeno,hraci);

 menu(jmeno);

 rewrite(f);
 p:=1;
 while (hraci[p].jmeno<>neutral) and (p<=maxhrac) {chr(255)} do p:=p+1; {zjisti pocet lidi v listine}
 inlist:=p-1;
 if inlist<>0 then
 begin
  p:=1;
  repeat
   write(f,hraci[p]);
   p:=p+1;
  until p=inlist+1;
 end;            {vsichni hraci v listine jsou zapsani do souboru f}
 close(f);

END.